public class Swapper { 
        private Robot robot; 
        private Robot robot1; 
        public static void main(String[] args) { 
                Swapper swapper = new Swapper(); 
                swapper.createEnviroment(); 
                swapper.swapAll(); 
        }//main

        public void createEnviroment() { 
                RobotWorld world = RobotWorld.load("swap1.txt"); 
                robot = new Robot(world.getNumRows() - 2, 2, Robot.NORTH, world); 
                robot.setDelay(100); 
        }//createEnviroment 


	//Swapping colors on all across cells in the corridor.
	//before: The robot is located at the beginning of the corridor, facing the corridor.
	//after:     The robot has the same location and facing the same direction.
	public void swapAll() { 
     		boolean finished = false; 
     		while (!finished) {
			swapAcrossCells();
          		if (!isAtEndOfCorridor()) 
               			robot.move(); 
          		else 
               			finished = true; 
     		} 
     		returnToStartPosition(); 
	}//swapAll 

	//Swapping colors of two across cells. 
	//before: The robot is in the corridor facing the corridor. 
	//after:    The robot is in the corridor, facing the same direction.
	private void swapAcrossCells() { 
		if (isLeftCellDark() != isRightCellDark()) 
			changeColorsOfAcrossCells(); 
	}//swapAcrossCells 

	//Returns true if the cell on left side of the robot is dark, otherwise false. 
	//before: The robot is in the corridor facing the corridor. 
	//after:    The robot is in the corridor, facing the same direction.
	private boolean isLeftCellDark() { 
		robot.turnLeft(); 
		robot.move(); 
		boolean isDark = robot.onDark(); 
		turnAround(); 
		robot.move(); 
		robot.turnLeft(); 
		return isDark; 
	}// isLeftCellDark

	//Returns true if the cell on right side of the robot is dark, otherwise false. 
	//before: The robot is in the corridor facing the corridor. 
	//after:    The robot is in the corridor, facing the same direction.
	private boolean isRightCellDark() { 
		turnRight(); 
		robot.move(); 
		boolean isDark = robot.onDark(); 
		turnAround(); 
		robot.move(); 
		turnRight(); 
		return isDark; 
	}//isRightCellDark

	//Change colors of the cells on left side and on right side of the robot. 
	//before: The robot is in the corridor facing the corridor. 
	//after:    The robot is in the corridor, facing the same direction.
	private void changeColorsOfAcrossCells() { 
		changeColorOfLeftCell(); 
		changeColorOfRightCell(); 
	}//changeColorsOfAcrossCells

	//Change color of the cell on left side of the robot. 
	//before: The robot is in the corridor facing the corridor. 
	//after:    The robot is in the corridor, facing the same direction. 
	private void changeColorOfLeftCell() { 
		robot.turnLeft(); 
		robot.move(); 
		switchColor();
		turnAround(); 
		robot.move(); 
		robot.turnLeft(); 
	}//changeColorOfLeftCell

	//Change color of the cell on right side of the robot. 
	//before: The robot is in the corridor facing the corridor. 
	//after:    The robot is in the corridor, facing the same direction.
	private void changeColorOfRightCell() { 
		turnRight(); 
		robot.move(); 
		switchColor();
		turnAround(); 
		robot.move(); 
		turnRight(); 
	}//changeColorOfRightCell

	//before: None.
	//after:  The robot has turned 90 degree to right.
	public void turnRight() {
		turnAround();
		robot.turnLeft();
	}//turnRight 

	//before: None.
	//after: The robot is facing the opposite direction.
	private void turnAround() {
		robot.turnLeft();
		robot.turnLeft();
	}//turnAround 

	//Switch color of the cell.
	//before: None.
	//after:    If the cell, the robot is located, at was dark it has become light, 
	//            and if the cell was light it has become dark.
	private void switchColor() {
		if (robot.onDark()) 
			robot.makeLight(); 
		else 
			robot.makeDark(); 
	}//switchColor

	//before: The robot is at end of the corridor, facing the wall. 
	//after:    The robot is at beginning of the corridor, facing the corridor. 
	private void returnToStartPosition() { 
		turnAround(); 
		goToEndOfCorridor(); 
		turnAround(); 
	}//returnToStartPosition 

	//returns true if the robot is at the end of the corridor, otherwise false
	public boolean isAtEndOfCorridor()  {
		return !robot.frontIsClear();
	}//isAtEndOfCorridor

	//before: The robot is in the corridor, facing the cooridor. 
	//after:    The robot is at the end of the corridor, facing the wall. 
	private void goToEndOfCorridor() { 
		while (!isAtEndOfCorridor()) { 
			robot.move(); 
		}
	}//goToEndOfCorridor 
}//Swapper
